const axios = require('axios')
const regions = require('./utils/aws/regions')

const call = async (SID = '', functionName, args = {}) => {
  const restApiId = SID.substring(2)
  const regionId = SID[0]
  const region = regions[regionId]

  if (!region) {
    throw new Error('Please provide a valid SID')
  }

  const url = `https://${restApiId}.execute-api.${region}.amazonaws.com/dev/s`

  const headers = {
    's-function': functionName
  }

  try {
    const res = await axios({
      method: 'post',
      url,
      headers,
      data: args
    })
    return res.data
  } catch (e) {
    throw new Error(e.response.data.error)
  }
}

const S = (config) => config.import.reduce((accum, functionName) => {
  accum[functionName] = async (args) => call(config.SID, functionName, args)
  return accum
}, {})

module.exports = S

// if (typeof window !== 'undefined') {
//   window.S = S
// } else {
//   module.exports = S
// }
