const path = require('path')
const R = require('ramda')
const dotenv = require('dotenv')

const fs = require('./fs')

const {mergeDeepRight} = R
const {fileExists} = fs

dotenv.config()

module.exports = async () => {
  if (!await fileExists(path.join(process.cwd(), 'index.js'))) {
    throw new Error('index.js not found in the current working directory.')
  }
  const indexJs = require(path.join(process.cwd(), 'index.js'))

  // todo validate index.js exports an object of functions

  const defaultConfig = {
    name: path.basename(process.cwd()),
    description: 'Build your dream serverless library',
    memory: 128,
    timeout: 10,
    region: 'us-east-1'
  }

  const userConfig = indexJs.config || {}

  // todo validate userConfig is an object or function that returns an object

  return mergeDeepRight(defaultConfig, userConfig)
}
